
var hBookmarkName;
var hBookmarkNameOrig;
var hBookmarkURL;
var hBookmarkTitle;
var hBookmarkLoc;
var compBookmarkURL;
var compBookmarkName;
var compBookmarkDesc;
var btnReduceBKName;

var reducedBK = false;
var bookDS;
var ftree;
var htmldoc;
var Hyper;
var returnval;
var bwin;
var canvas;
var hypTF;

function Startup()
{
	Hyper = window.arguments[0];
	bookDS = Hyper.bookDS;
	HypCommon.createDS(Hyper.bookDS, null, Hyper.histDS); //in case roots are missing
	
	
	ftree = document.getElementById("ftree");
	ftree.database.AddDataSource(bookDS.getRawDataSource());
	ftree.builder.rebuild();
	btnReduceBKName = document.getElementById("btnReduceName");
	
	htmldoc = window.arguments[1];
	hBookmarkName = htmldoc.title;
	hBookmarkNameOrig = htmldoc.title;
	
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	if (hBookmarkName == "")
	{
		hBookmarkName = htmldoc.URL;
		hBookmarkNameOrig = htmldoc.URL;
		btnReduceBKName.hidden = true;
	}
	else
	{
		//reduce bookmark name automatically (if set in preferences)
		if (prefs.getBoolPref("extensions.hyper.reduceBKName"))
		{
			hBookmarkName = HypCommon.reduceBookmarkName(hBookmarkNameOrig);
			reducedBK = true;
			btnReduceBKName.label = HypCommon.getString("EXPAND");
		}
		else
			btnReduceBKName.label = HypCommon.getString("REDUCE");
	}
	
	hBookmarkURL = htmldoc.URL;
	hBookmarkLoc = window.arguments[2];
	hBookmarkTitle = hBookmarkName;
	hypTF = window.arguments[3];
	bwin = window.arguments[4];
	returnval = window.arguments[5];
	
	compBookmarkURL = document.getElementById("bookurl");
	compBookmarkURL.value = hBookmarkURL;
	compBookmarkName = document.getElementById("tbName");
	compBookmarkName.value = hBookmarkName;
	compBookmarkDesc = document.getElementById("bkdesc");
	if (prefs.getBoolPref("extensions.hyper.usebkdesc"))
	{
		compBookmarkDesc.hidden = false; //SHOW bookmark description
	}
	compBookmarkDesc.value = "";
	
	var compBookmarkTitle = document.getElementById("booktit");
	compBookmarkTitle.value = hBookmarkNameOrig;
	
	var btnLastBK = document.getElementById("btnAutoBK");
	if (returnval.lastBKF != null)
	{
		var nd = bookDS.getNode(returnval.lastBKF);
		var st = nd.getTarget("http://home.netscape.com/NC-rdf#Name");
		if (st != null) btnLastBK.label = HypCommon.getString("BK_IN_BTN") +" " + st.getValue();
		else btnLastBK.setAttribute("hidden", "true");
	}
	else btnLastBK.setAttribute("hidden", "true");
	
	//set parent folder
	selectParent(hBookmarkLoc.getValue());
	
	if (hBookmarkLoc.getValue() == returnval.lastBKF) btnLastBK.setAttribute("hidden", "true"); //hide if same
	
	canvas = document.getElementById("bkthumb");
	HypCommon.drawThumbnail(bwin, canvas);
	
	return true;
}

function selectParent(parent)
{
	var sloc = null;
	if ((parent != null) && (ftree.view != null))
	{
		sloc = parent;
	
		for(var i=0; i<ftree.view.rowCount; i++)
		{
			if (sloc == ftree.view.getResourceAtIndex(i).Value) //ftree.view.getItemAtIndex(i).id)
			{
				ftree.view.selection.select(i);
				ftree.treeBoxObject.ensureRowIsVisible(i);
				break;
			}
		}
	}
	ftree.focus();
}


function reduceName()
{
	if (reducedBK) //thus need to expand
	{
		compBookmarkName.value = hBookmarkNameOrig;
		btnReduceBKName.label = HypCommon.getString("REDUCE");
		reducedBK = false;
	}
	else
	{
		hBookmarkName = HypCommon.reduceBookmarkName(hBookmarkNameOrig);
		compBookmarkName.value = hBookmarkName;
		btnReduceBKName.label = HypCommon.getString("EXPAND");
		reducedBK = true;
	}
}

function onOK()
{
	var i = -1;
	if (ftree.view != null) //in case of newly created bookmark file
		i = ftree.view.selection.currentIndex;
	var nname;
	if (i == -1)
		nname = "NC:BookmarksRoot";
	else
		nname = ftree.view.getResourceAtIndex(i).Value; //ftree.view.getItemAtIndex(i).id; //folder name ...?
	
	var bkname = compBookmarkName.value; //bookmark name in textbox
	var bkurl = hBookmarkURL;  //bookmark url in label
	
	var folder = bookDS.getNode(nname);
	if ((nname == "NC:BookmarksRoot") && (!folder.isContainer())) HypCommon.createDS(Hyper.bookDS, Hyper.fastbkDS, Hyper.histDS); //when root name is not present
	if (!folder.isContainer())
	{
		//alert("Please Select a folder...not "+ nname);
		return false;
	}
	
	var bkuri = bkurl;
	var bookmark = bookDS.getNode("NC:"+bkuri);
	
	//Check that is not already created ......
	var bkcf = HypCommon.BKCheckPresent(bookmark, folder);
	
	folder.addChild(bookmark, false); //do not add if already present
  	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Name", bkname);
  	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#URL", bkurl);
  	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Page", hBookmarkTitle);
  	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#VisitCount", "1");
  	if (returnval.icon != null) bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Icon", returnval.icon); ///icon
  	else bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Icon", "chrome://hyper/content/images/file.png");
  	
  	var s = HypCommon.dateToStr(new Date(), false);
  	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#BookmarkAddDate", s);
  	bookmark.addTargetOnce("http://home.netscape.com/WEB-rdf#LastVisitDate", s); //set last visit date as add bookmark date
	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Keywords", HypCommon.getKeylist(hypTF, 0));
	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#OrigKeywords", HypCommon.getKeylist(hypTF, 2));
	
	compBookmarkDesc.value = HYTrim(compBookmarkDesc.value); //.replace(/^\s+|\s+$/, ""); //Trim
	if (compBookmarkDesc.value != "")
	{
		bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Description", compBookmarkDesc.value);
	}
	
	if (returnval.seref != null) bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Referrer", returnval.seref);
	
	if (bkcf) //delete cache
	{
		var cachep = bookmark.getTarget("http://home.netscape.com/NC-rdf#ShortcutURL");
		var cachefp = bookmark.getTarget("http://home.netscape.com/NC-rdf#Image");
		HypCommon.BKDelCache(cachefp, cachep);
	}
	
	var cachepath = HypCommon.saveHTMLCache(Hyper, htmldoc);
	var cpath = "file://" + HypCommon.userHome("hyperCache", cachepath+".html");
	cpath = cpath.replace(/\s/g, "%20");
	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#ShortcutURL", cpath);
	var fp = HypCommon.saveThumbFile(cachepath, canvas);
	fp = "file://" + fp.replace(/\s/g, "%20");
	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Image", fp);
	
	bookDS.save();

	returnval.pfol = nname;
	returnval.pfolnode = folder;
	
	return true;
}

function newFolder()
{
	var retval = new Object();
	window.openDialog("chrome://hyper/content/hyperFolder.xul", "" , "centerscreen,chrome,dialog=yes,resizable=yes,modal=yes", bookDS, Hyper.histDS, "", retval);
	ftree.builder.rebuild();
	
	//select folder that was last added
	if (retval.created)
	for(var i=0; i<ftree.view.rowCount; i++)
	{
		if (retval.created == ftree.view.getResourceAtIndex(i).Value) //ftree.view.getItemAtIndex(i).id)
		{
			ftree.view.selection.select(i);
			break;
		}
	}
	ftree.focus();
}

function autoBK()
{
	//set parent folder
	selectParent(returnval.lastBKF);
	
	onOK();
	
	window.close();
}