
var ftree;
var bookDS;
var tbpath;
var fparent;
var fp;
var nsIFilePicker;
var rnet;
var fpres;

//var RDFService = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);

function Startup()
{
	bookDS = window.arguments[0];
	
	ftree = document.getElementById("ftree");
	ftree.database.AddDataSource(bookDS.getRawDataSource());
	ftree.builder.rebuild();
	
	tbpath = document.getElementById("tbpath");
	tbpath.value = "";
	
	nsIFilePicker = Components.interfaces.nsIFilePicker;
	fpres = nsIFilePicker.returnCancel;
	fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	rnet = document.getElementById("rnet");
}

function recGet(node) //get string for netscape bookmark file
{
	var s = "";
	var chil = node.getChildren();
	while (chil.hasMoreElements())
	{
		var bk = chil.getNext();
		if (bk.isContainer())
		{
			try {
			var bfname = bk.getTarget("http://home.netscape.com/NC-rdf#Name");
			var foldate = bk.getTarget("http://home.netscape.com/NC-rdf#BookmarkAddDate");
			if (foldate != null) foldate = foldate.getValue();
			var ddate = HypCommon.sDateConv(foldate);
			var dt_add = Math.floor(ddate.getTime()*0.001); //convert to Bookmark DateTime
			
			s = s + "    <DT><H3 FOLDED ADD_DATE=\"" + dt_add + "\">" + bfname.getValue() + "</H3>\r\n    <DL><p>\r\n" + recGet(bk) +"    </DL><p>\r\n";
			} catch (err) {}
		}
		else
		{
			try {
			var bname = bk.getTarget("http://home.netscape.com/NC-rdf#Name");
			var burl = bk.getTarget("http://home.netscape.com/NC-rdf#URL");
			var bkadd = bk.getTarget("http://home.netscape.com/NC-rdf#BookmarkAddDate");
			var bklastvisit = bk.getTarget("http://home.netscape.com/WEB-rdf#LastVisitDate");
			
			var ddate = HypCommon.sDateConv(bkadd.getValue());
			var dt_add = Math.floor(ddate.getTime()*0.001); //convert to Bookmark DateTime
			
			var lastvisitdate = bklastvisit.getValue();
			if ((lastvisitdate == null) || (lastvisitdate == ""))
			{
				s = s + "        <DT><A HREF=\"" + burl.getValue() + "\" ADD_DATE=\"" + dt_add + "\">" + bname.getValue() + "</A>\r\n"; 
			}
			else
			{
				var lvdate = HypCommon.sDateConv(lastvisitdate);
				var dt_lv = Math.floor(lvdate.getTime()*0.001); //convert to Bookmark DateTime
				s = s + "        <DT><A HREF=\"" + burl.getValue() + "\" ADD_DATE=\"" + dt_add + "\" LAST_VISIT=\""+ dt_lv +"\" LAST_MODIFIED=\""+ dt_lv +"\">" + bname.getValue() + "</A>\r\n"; 
			}
			
			//var ad = RDFService.GetDateLiteral(ddate);
			//s = s + "        <DT><A HREF=\"" + burl.getValue() + "\" ADD_DATE=\"" + ad.value + "\">" + bname.getValue() + "</A>\r\n"; 
			} catch (err) {}
		}
	}
	
	return s;
}

function finish()
{
	var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(Components.interfaces.nsIFileOutputStream);
	var file =  Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	file.initWithPath(tbpath.value);
	if (file.exists()) file.remove(false);
	file.create(0x00, 0644);
	
	var content = "";
	
	if (rnet.selected)
	{
		var s = "<!DOCTYPE NETSCAPE-Bookmark-file-1> \r\n" +
			"<!-- This is an automatically generated file by HyperBK Bookmark Manager for Firefox. -->\r\n" +
			"<TITLE>Bookmarks</TITLE>\r\n" +
			"<H1>Bookmarks</H1>\r\n" +
			"<DL><p>\r\n";
			
		var rootpar = bookDS.getNode(fparent);
		content = s + recGet(rootpar) + "</DL><p>";
	}
	else
	 	content = bookDS.serializeToString();
	
	outputStream.init(file, 0x20 | 0x02, 00004, null);
	outputStream.write(content, content.length);
	outputStream.flush();
	outputStream.close();
}

function selectFolder()
{
	var i = ftree.view.selection.currentIndex;
	if (i == -1)
	{
		alert(HypCommon.getString("SEL_FOLDER"));
		return false;
	}
	
	fparent = ftree.view.getResourceAtIndex(i).Value; //ftree.view.getItemAtIndex(i).id; 
	return true;
}

function selectPath()
{
	if (tbpath.value == "")
	{
		alert(HypCommon.getString("ENTER_FILENAME"));
		return false;
	}
	
	var f = tbpath.value;
	var extpos = f.lastIndexOf('.');
	if (extpos > 0) tbpath.value = f.substr(0, extpos); //strip it off always
	//if (extpos < tbpath.value.length - 5)
	//{
		if (rnet.selected) tbpath.value = tbpath.value + ".html";
		else tbpath.value = tbpath.value + ".rdf";
	//}
	return true;
}


function browsebtn()
{
	fp.init(window, HypCommon.getString("SELECT_FILE"), nsIFilePicker.modeSave);
	fp.appendFilters(nsIFilePicker.filterHTML);
	fp.appendFilter("RDF File","*.rdf");
	fpres = fp.show();
	if (fpres != nsIFilePicker.returnCancel) 
	{
		tbpath.value = fp.file.path;
	}
}

function prefinish()
{
	var lb = document.getElementById("lbfexp");
	var par = bookDS.getNode(fparent);
	try { 
	var st = par.getTarget("http://home.netscape.com/NC-rdf#Name");
	lb.value = st.getValue();
	}
	catch (err) {}
	
	lb = document.getElementById("lbspath");
	lb.value = tbpath.value;
	
	lb = document.getElementById("lbtype");
	if (rnet.selected) lb.value = HypCommon.getString("OUTPUT_NETSCAPE_FILE");
	else lb.value = HypCommon.getString("OUTPUT_RDF_FILE");
}