//Dialog to Show Folders and Create new one

var compFolderName;
var compFolderDesc;

var bookDS;
var histDS;
var ftree;
var returnval = null;

function Startup()
{ 
	bookDS = window.arguments[0];
	histDS = window.arguments[1];
	
	compFolderName = document.getElementById("tbName");
	compFolderName.value = window.arguments[2];
	returnval = window.arguments[3];
	
	try{
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		compFolderDesc = document.getElementById("bkdesc");
		compFolderDesc.value = "";
		if (prefs.getBoolPref("extensions.hyper.usebkdesc"))
		{
			compFolderDesc.hidden = false; //SHOW bookmark description  or folder
		}
	}
	catch (err) {}
	
	ftree = document.getElementById("ftree");
	ftree.database.AddDataSource(bookDS.getRawDataSource());
	ftree.builder.rebuild();
}


function onOK()
{
	var fname = compFolderName.value;
	if (fname == "")
	{
		alert(HypCommon.getString("ENT_FOLDER_NAME"));
		compFolderName.focus();
		return false;
	}
	
	var nname;
	var i = -1; 
	
	if (ftree.view != null) i = ftree.view.selection.currentIndex;
	if (i == -1)
		nname = "NC:BookmarksRoot";
	else
		nname = ftree.view.getResourceAtIndex(i).Value; //ftree.view.getItemAtIndex(i).id; //folder name ...?
	
	var parentfolder = bookDS.getNode(nname);
	if ((nname == "NC:BookmarksRoot") && (!parentfolder.isContainer())) HypCommon.createDS(bookDS, null, histDS); //when root name is not present
	if (!parentfolder.isContainer())
	{
		//alert("Please select a folder to put in... not a bookmark");
		return false;
	}
	var furi = fname.replace(/\s/g, "_");
	var folder = bookDS.getNode("NC:"+furi);
	var tf = folder.getTarget("http://home.netscape.com/NC-rdf#Name");
	if (tf != null)
	{
		alert(HypCommon.getString("DIFF_FOLDER_NAME"));
		compFolderName.focus();
		return false;
	}
	folder.makeSeq(); //MAKE SEQUENCE
	folder.addTarget("http://home.netscape.com/NC-rdf#Name",fname);
	var dates = HypCommon.dateToStr(new Date(), false);
  	folder.addTargetOnce("http://home.netscape.com/NC-rdf#BookmarkAddDate", dates); //fixed ... new
  	
	parentfolder.addChild(folder);
	
	compFolderDesc.value = HYTrim(compFolderDesc.value); //.replace(/^\s+|\s+$/, ""); //Trim
	if (compFolderDesc.value != "")
	{
		folder.addTargetOnce("http://home.netscape.com/NC-rdf#Description", compFolderDesc.value);
	}
	
	bookDS.save();
	
	///now history
	var hparentfol = histDS.getNode(nname);
	var hfol = histDS.getNode("NC:"+furi);
	hfol.makeBag();
	hfol.addTarget("http://home.netscape.com/NC-rdf#Name",fname);
	hparentfol.addChild(hfol);
	histDS.save();
	
	if (returnval != null) returnval.created = folder.getValue();
	
	return true;
}