//uses google web service to conduct search

var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var ngets = 5; //maximum number of results
var reslist = null;
var pmeter;
var HY_OpenTab;
var listDS = null;
var q;
var key;
var retry = 0;
var qlab;
var starts = 0;
var page = "";
var spanel = null;

function Startup()
{
	key = prefs.getCharPref("extensions.hyper.googleDevKey");
	if (key == "")
	{
		alert(HypCommon.getString("MISSING_GDK"));
		window.close();
		return;
	}
	
	window.document.title = window.arguments[1] + " " + window.document.title;
	
	spanel = document.getElementById("span1");
	page = document.getElementById("span1b");
	pmeter = document.getElementById("pmeter");
	pmeter.setAttribute("mode", "undetermined");
	var apptit = document.getElementById("apptit");
	apptit.value = window.arguments[0];
	
	q = window.arguments[2]; //query
	if ((q == "") || (q == null))
	{ 
		alert(HypCommon.getString("FAILED_EMPTY_QUERY"));
		window.close();
		return;
	}
	HY_OpenTab = window.arguments[3]; //function to open link in new tab
	
	qlab = document.getElementById("querystr");
	qlab.value = q;
	reslist = document.getElementById("gresults");
	
	listDS = new RDFDataSource();
	
	retry = 0;
	callSearch();
}

function callSearch()
{
	googleSearch(q, starts, ngets, false, "", false, "", "latin1", "latin1", key, showResults);
}

function gobtn()
{
	if (qlab.value == "")
	{
		alert(HypCommon.getString("ENT_QUERY_STR"));
		return;
	}
	q = qlab.value;
	retry = 0;
	pmeter = document.getElementById("pmeter");
	pmeter.setAttribute("mode", "undetermined");
	callSearch();
}

function nextprev(pg)
{
	if ((starts <= 0) && (pg < 0)) return;
	
	starts = starts + pg * ngets;
	var p = (starts / ngets) + 1;
	page.label = HypCommon.getString("PAGE")+" " + p;
	spanel.label = HypCommon.getString("SENT_SOAP");
	gobtn();
}

function showResults(results)
{ 	
	var rootn = listDS.getNode("NC:LRoot");
	var n = rootn.getChildCount();
	for(var i=0; i<n; i++) rootn.removeChildAt(1);
	rootn.makeBag();
	
	try
	{
		var urls = results.body.getElementsByTagName("URL");
		var titles = results.body.getElementsByTagName("title");
		var snippets = results.body.getElementsByTagName("snippet");
		
		if (urls.length == 0) throw "No Results";
		
		for(var i=0; i<urls.length; i++)
		{
			var url = urls[i].firstChild.nodeValue; 
			var name = removeTags(titles[i].firstChild.nodeValue);
			var snip = removeTags(snippets[i].firstChild.nodeValue);
			var nd = listDS.getNode("NC:"+url);
			
			nd.addTarget("http://home.netscape.com/NC-rdf#Name", name);
			nd.addTarget("http://home.netscape.com/NC-rdf#URL", url);
			nd.addTarget("http://home.netscape.com/NC-rdf#description", snip);
			rootn.addChild(nd);
		}
		spanel.label = HypCommon.getString("READY");
		
		reslist.database.AddDataSource(listDS.getRawDataSource());
		reslist.builder.rebuild();
		pmeter.setAttribute("mode", "determined");
		pmeter.setAttribute("value", "100%");
	}
	catch (err)
	{
		if (retry < 3)
		{
			callSearch();
			retry++;
			spanel.label = HypCommon.getString("FAILED_RETRY")+" " + retry;
		}
		else
		{
			spanel.label = HypCommon.getString("FAILED");
			pmeter.setAttribute("mode", "determined");
			pmeter.setAttribute("value", "0%");
		}
	}
}

function openGLink()
{
	//if (urls == null) return;
	if (reslist.selectedIndex < 0) return;
	//alert(reslist.getItemAtIndex(reslist.selectedIndex).value);
	HY_OpenTab(reslist.getItemAtIndex(reslist.selectedIndex).value);
}

function removeTags(s)
{
	var x = s.replace(/<[^<>]+>/g, "");
	x = x.replace(/&gt;/g, ">");
	x = x.replace(/&lt;/g, "<");
	return x;
}