
var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
var ngets = 5; //maximum number of results
var reslist = null;
var pmeter;
var HY_OpenTab;
var listDS = null;
var q;
var qq;
var key;
var retry = 0;
var qlab;
var hiframe = null;

var mode="";

function Startup()
{
	/*key = prefs.getCharPref("extensions.hyper.googleDevKey");
	if (key == "")
	{
		alert("Missing Google Developer Key");
		window.close();
		return;
	}
	*/
	window.document.title = window.arguments[1] + " " + window.document.title;
	
	pmeter = document.getElementById("pmeter");
	pmeter.setAttribute("mode", "undetermined");
	var apptit = document.getElementById("apptit");
	apptit.value = window.arguments[0];
	
	q = window.arguments[2]; //query
	if ((q == "") || (q == null))
	{
		window.close();
		return;
	}
	HY_OpenTab = window.arguments[3]; //function to open link in new tab
	qq = q;
	//q = "site:directory.google.com "+q;
	
	if (window.arguments.length > 3)
	{
		if (window.arguments[4] == "googlemain")
			mode = "googlemain"
	}
	qlab = document.getElementById("querystr");
	qlab.value = q;
	reslist = document.getElementById("gresults");
	
	hiframe = document.getElementById("hiframe");
	hiframe.addEventListener("DOMContentLoaded", GDLoad, true);
	
	retry = 0;
	qq = escape(qq);
	
	callSearch2();
}

function callSearch2()
{
	if (mode == "googlemain")
		hiframe.setAttribute("src", "http://www.google.com/search?q=" + qq);
	else
		hiframe.setAttribute("src", "http://www.google.com/search?q=" + qq +"&hl=en&cat=gwd%2FTop");
}

function GDLoad(e)
{
	var conn = e.originalTarget;
	var twin = e.target.defaultView;
	var anc = conn.defaultView.document.getElementsByTagName("A");
	
	for(var i=0; i<anc.length; i++)
	{
		anc[i].setAttribute("target", "_blank");
	}
	
	//listDS = new RDFDataSource();
	//var rootn = listDS.getNode("NC:LRoot");
	//rootn.makeBag();
	
	/*for(var i=0; i<anc.length; i++)
	{
		var url;
		//if (anc[i].hasAttribute("id") == false)
			url = anc[i].getAttribute("href"); 
		if (url == null) url = "";
		var name = anc[i].getAttribute("id"); //removeTags(titles[i].firstChild.nodeValue);
		if (name == null) name = "";
		var snip = "";//removeTags(snippets[i].firstChild.nodeValue);
		var nd = listDS.getNode("NC:"+url);
		
		nd.addTarget("http://home.netscape.com/NC-rdf#Name", name);
		nd.addTarget("http://home.netscape.com/NC-rdf#URL", url);
		nd.addTarget("http://home.netscape.com/NC-rdf#description", snip);
		rootn.addChild(nd);
	}*/
	var spanel = document.getElementById("span1");
	spanel.label = HypCommon.getString("READY");
	
	//reslist.database.AddDataSource(listDS.getRawDataSource());
	//reslist.builder.rebuild();
	pmeter.setAttribute("mode", "determined");
	pmeter.setAttribute("value", "100%");
}

function callSearch()
{
	googleSearch(q, 0, ngets, false, "", false, "", "latin1", "latin1", key, showResults);
}


function gobtn()
{
	if (qlab.value == "")
	{
		alert(HypCommon.getString("ENT_QUERY_STR"));
		return;
	}
	q = qlab.value;
	retry = 0;
	pmeter = document.getElementById("pmeter");
	pmeter.setAttribute("mode", "undetermined");
	qq = escape(q);
	callSearch2();
}

function showResults(results)
{ 	
	var spanel = document.getElementById("span1");
	
	listDS = new RDFDataSource();
	var rootn = listDS.getNode("NC:LRoot");
	rootn.makeBag();
	
	try
	{
		var urls = results.body.getElementsByTagName("URL");
		var titles = results.body.getElementsByTagName("title");
		var snippets = results.body.getElementsByTagName("snippet");
		
		if (urls.length == 0) throw "No Results";
		
		for(var i=0; i<urls.length; i++)
		{
			var url = urls[i].firstChild.nodeValue; 
			var name = removeTags(titles[i].firstChild.nodeValue);
			var snip = removeTags(snippets[i].firstChild.nodeValue);
			var nd = listDS.getNode("NC:"+url);
			
			nd.addTarget("http://home.netscape.com/NC-rdf#Name", name);
			nd.addTarget("http://home.netscape.com/NC-rdf#URL", url);
			nd.addTarget("http://home.netscape.com/NC-rdf#description", snip);
			rootn.addChild(nd);
		}
		spanel.label = "Ready";
		
		reslist.database.AddDataSource(listDS.getRawDataSource());
		reslist.builder.rebuild();
		pmeter.setAttribute("mode", "determined");
		pmeter.setAttribute("value", "100%");
	}
	catch (err)
	{
		if (retry < 3)
		{
			callSearch();
			retry++;
			spanel.label = "Failed....Retry " + retry;
		}
		else
		{
			spanel.label = "Failed";
			pmeter.setAttribute("mode", "determined");
			pmeter.setAttribute("value", "0%");
		}
	}
}

function openGLink()
{
	//if (urls == null) return;
	if (reslist.selectedIndex < 0) return;
	//alert(reslist.getItemAtIndex(reslist.selectedIndex).value);
	HY_OpenTab(reslist.getItemAtIndex(reslist.selectedIndex).value);
}

function removeTags(s)
{
	var x = s.replace(/<[^<>]+>/g, "");
	x = x.replace(/&gt;/g, ">");
	x = x.replace(/&lt;/g, "<");
	return x;
}