var Hyper = null;
var oldf = null; //folder that is 'full'
var newf = null;
var bookDS = null;
var histDS = null;
var plist;
var nlist;
var newfname = "";
var newfparent = null;
var ftree;

function Startup()
{
	Hyper = window.arguments[0];
	oldf = window.arguments[1];
	
	bookDS = Hyper.bookDS;
	histDS = Hyper.histDS;
	
	var oldflb = document.getElementById("bkfname");
	var sto = oldf.getTarget("http://home.netscape.com/NC-rdf#Name");
	oldflb.value = sto.getValue();
}

function finish()
{
	//first create new folder
	newfname = newfname.replace(/\s/g, "_");
	newf = bookDS.getNode("NC:"+newfname);
	newf.addTargetOnce("http://home.netscape.com/NC-rdf#Name",newfname);
	newf.makeSeq();
	var parent = bookDS.getNode(newfparent);
	parent.addChild(newf);
	
	//create equivalent history folder for new folder
	var histnf = histDS.getNode("NC:"+newfname);
	histnf.addTargetOnce("http://home.netscape.com/NC-rdf#Name",newfname);
	histnf.makeBag();
	var histpar = histDS.getNode(newfparent);
	histpar.addChild(histnf);
	
	//get new folder listbox items and add to new folder
	var rowc = nlist.getRowCount();
	for(var i=0; i<rowc; i++)
	{
		var itm = nlist.getItemAtIndex(i);
		var bk = bookDS.getNode(itm.value);
		oldf.removeChild(bk);
		newf.addChild(bk);
	}
	
	//save book ds
	bookDS.save();
	histDS.save();

	return true;
}


function pageone()
{
	ftree = document.getElementById("ftree");
	ftree.database.AddDataSource(bookDS.getRawDataSource());
	ftree.builder.rebuild();
	
	var oldfname = oldf.getValue();
	for(var i=0; i<ftree.view.rowCount; i++)
	{
		if (oldfname == ftree.view.getResourceAtIndex(i).Value) //ftree.view.getItemAtIndex(i).id)
		{
			ftree.view.selection.select(i);
			break;
		}
	}
}

function pageonehide()
{
	newfname = document.getElementById("newfname").value;
	if (newfname == "")
	{
		alert(HypCommon.getString("ENTER_FOLNAME"));
		return false;
	}
	
	var i = ftree.view.selection.currentIndex;
	if (i == -1)
	{
		alert(HypCommon.getString("PLS_SEL_FOL"));
		return false;
	}
	newfparent = ftree.view.getResourceAtIndex(i).Value; //ftree.view.getItemAtIndex(i).id; 
	
	var chil = bookDS.getAllResources();
	while (chil.hasMoreElements())
	{
		var f = chil.getNext();
		if (f.isContainer())
		{
			var st = f.getTarget("http://home.netscape.com/NC-rdf#Name");
			if (st.getValue() == newfname)
			{
				alert(HypCommon.getString("FOL_ALREADY_EXISTS"));
				return false;
			}
		}
	}
	
	return true;
}

function pagetwo()
{
	var oldflb = document.getElementById("oldfname");
	var newflb = document.getElementById("newfname");
	var sto = oldf.getTarget("http://home.netscape.com/NC-rdf#Name");
	oldflb.value = sto.getValue();
	newflb.value = newfname; //still not created
	
	plist = document.getElementById("oldf");
	nlist = document.getElementById("newf");
	var rauto = document.getElementById("raut");
	if (rauto.selected) //automatic division
	{
		var keys = "";
		var chil = oldf.getChildren();
		while (chil.hasMoreElements())
		{
			var bk = chil.getNext();
			var bkkeys = bk.getTarget("http://home.netscape.com/NC-rdf#Keywords");
			keys = keys + bkkeys.getValue();
		}
		keys = keys.split(";"); //split all keywords from all bookmarks
		var keysl = new Array();
		var count = 0;
		for(var i=0; i<keys.length; i++)
		{
			count = 0;
			if (keys[i] != "")
			{
				for(var j=0; j<keys.length; j++)
				{
					if ((i != j) && (keys[i] == keys[j]))
					{
						count++;
						keys[j] = "";
					}
				}
				keysl[keysl.length] = new Array(keys[i], count); //count the occurance of each keyword
			}
		}
		
		keysl.sort(sortwords); //sort keywords
		chil = oldf.getChildren();
		while (chil.hasMoreElements())
		{
			var bk = chil.getNext();
			var bkkeys = bk.getTarget("http://home.netscape.com/NC-rdf#Keywords");
			bkkeys = bkkeys.getValue();
			bkkeys = bkkeys.split(";");
			count = 0;
			for (var i=0; i<bkkeys.length; i++) //if bookmark has keywords in top 3
			{
				if (bkkeys[i] == keysl[0][0]) count++;
				if (bkkeys[i] == keysl[1][0]) count++;
				if (bkkeys[i] == keysl[2][0]) count++;
			}
			if (count >= 2) //keep in old folder
			{
				addToList(bk, plist);
			}
			else
			{
				addToList(bk, nlist);
			}
		}
	}
	else //just fill parent....user will move to folder
	{
		var chil = oldf.getChildren();
		while (chil.hasMoreElements())
		{
			var bk = chil.getNext();
			addToList(bk, plist);
		}
	}
}

function addToList(bk, list)
{
	var s = bk.getTarget("http://home.netscape.com/NC-rdf#Name");
	var itm = list.appendItem(s.getValue(), bk.getValue());
	itm.setAttribute("class", "listitem-iconic");
	if (bk.isContainer())
	{
		itm.image = "chrome://hyper/content/images/folder.png";
	}
	else
	{
		var ic = bk.getTarget("http://home.netscape.com/NC-rdf#Icon");
		if (ic != null) itm.image = ic.getValue();
		else itm.image = "chrome://hyper/content/images/file.png";
	}
}

function sortwords(a, b)
{
	return (b[1] - a[1]); //descending
}

function moveRight()
{
	var itm = plist.selectedItem;
	plist.removeItemAt(plist.selectedIndex);
	var nitm = nlist.appendItem(itm.label, itm.value);
	nitm.setAttribute("class", "listitem-iconic");
	nitm.image = itm.image;
}


function moveLeft()
{
	var itm = nlist.selectedItem;
	nlist.removeItemAt(nlist.selectedIndex);
	var nitm = plist.appendItem(itm.label, itm.value);
	nitm.setAttribute("class", "listitem-iconic");
	nitm.image = itm.image;
}