var bklist;
var histlist;
var fastbklist;
var resultlist;

var treeshown = 1; //tree that is currently shown 1-bookmarks, 2-history, 3-search results
var oldtreeshown = 1;
var resDS;

var bksearchTB;
var bookDS;
var histDS;
var fastbkDS;
var bktree;
var histtree;
var fastbktree;
var restree;
var Hyper;
var captitle;

function Startup()
{
	Hyper = window.parent.hyperObj;
	if (Hyper == null) alert("HyperBK Sidebar Failure");
	bookDS = Hyper.bookDS;
	histDS = Hyper.histDS;
	fastbkDS = Hyper.fastbkDS;
	
	bktree = window.document.getElementById("bktree");
	bktree.database.AddDataSource(bookDS.getRawDataSource());
	bktree.builder.rebuild();
	bktree.addEventListener("dblclick", tvisitBk, false);
	
	histtree = window.document.getElementById("histtree");
	histtree.database.AddDataSource(histDS.getRawDataSource());
	histtree.builder.rebuild();
	histtree.addEventListener("dblclick", tvisitHist, false);
	
	fastbktree = window.document.getElementById("fastbktree");
	fastbktree.database.AddDataSource(fastbkDS.getRawDataSource());
	fastbktree.builder.rebuild();
	fastbktree.addEventListener("dblclick", tvisitFastBk, false);
	
	resDS = new RDFDataSource();
	
	restree = window.document.getElementById("resulttree");
	restree.database.AddDataSource(resDS.getRawDataSource());
	restree.builder.rebuild();
	restree.addEventListener("dblclick", tvisitRes, false);
	
	bklist = window.document.getElementById("bktreebox");
	histlist = window.document.getElementById("histtreebox");
	fastbklist = window.document.getElementById("fastbktreebox");
	resultlist = window.document.getElementById("resulttreebox");
	
	bksearchTB = window.document.getElementById("bksearch");
	bksearchTB.addEventListener("keypress", tbkeypress, false);
	
	window.parent.hyperSidebarTree = bktree; //to be able to manage from outside
	
	captitle = window.document.getElementById("captitle");
	
	if (bktree.view != null) bktree.view.selection.clearSelection();
}

function tbkeypress(e)
{
	if (e.keyCode == 13) searchBH(); //enter key as click on Search Button
}

function searchBH()
{	
	if (bksearchTB.value == "")
	{
		alert(HypCommon.getString("PLS_ENTER_SQ"));
		return;
	}
	
	
	bksearchTB.value = HYTrim(bksearchTB.value);
	var sbox = bksearchTB.value;
	sbox = sbox.toLowerCase();
	
	var k = resDS.getAllResources(); //empty result datasource
	while (k.hasMoreElements())
	{
		var n = k.getNext();
		resDS.deleteRecursive(n);
	}
	
	switch (treeshown)
	{
		case 1 : searchBk(sbox); break;
		case 2 : searchHist(sbox); break;
		case 3 : searchFastBk(sbox); break;
		case 4 : if (oldtreeshown == 1) searchBk(sbox); 
			 else if (oldtreeshown == 2) searchHist(sbox);
			 else if (oldtreeshown == 3) searchFastBk(sbox); break;
	}
	showTree(4);
	restree.builder.rebuild();
}

function createResNode(name, url, icon)
{
	var node = resDS.getNode(url);
	node.addTarget("http://home.netscape.com/NC-rdf#Name", name);
	node.addTarget("http://home.netscape.com/NC-rdf#URL", url);
	if (icon != null) node.addTarget("http://home.netscape.com/NC-rdf#Icon", icon);
	var root = resDS.getNode("NC:ResultRoot");
	if (!root.isContainer()) root.makeBag();
	root.addChild(node);
}

function searchBk(sbox)
{
	var allbk = bookDS.getAllResources();
	while (allbk.hasMoreElements())
	{
		var bnode = allbk.getNext();
		if (bnode.isContainer() == false)
		{
		   try {
			var s = "";
			var bName = bnode.getTarget("http://home.netscape.com/NC-rdf#Name");
			var bURL = bnode.getTarget("http://home.netscape.com/NC-rdf#URL");
			var bKeywords = bnode.getTarget("http://home.netscape.com/NC-rdf#OrigKeywords");
			var bTitle = bnode.getTarget("http://home.netscape.com/NC-rdf#Page");
			var bIcon = bnode.getTarget("http://home.netscape.com/NC-rdf#Icon");
			if (bKeywords != null) s = bKeywords.getValue().replace(/;/g," ");
			s = bName.getValue() + " " + s + " " + bTitle.getValue();
			s = s.toLowerCase();
			if (HypCommon.searchMatch(sbox, s) >= 0)//found something
				createResNode(bName.getValue(), bURL.getValue(), bIcon.getValue());
		   } catch (err) {}
		}
	}
}

function searchFastBk(sbox)
{
	var allfbk = fastbkDS.getAllResources();
	while (allfbk.hasMoreElements())
	{
		var fbnode = allfbk.getNext();
		if (fbnode.isContainer() == false)
		{
		   try {
			var s = "";
			var bName = fbnode.getTarget("http://home.netscape.com/NC-rdf#Name");
			var bURL = fbnode.getTarget("http://home.netscape.com/NC-rdf#URL");
			var bKeywords = fbnode.getTarget("http://home.netscape.com/NC-rdf#OrigKeywords");
			var bTitle = fbnode.getTarget("http://home.netscape.com/NC-rdf#Page");
			var bIcon = fbnode.getTarget("http://home.netscape.com/NC-rdf#Icon");
			if (bKeywords != null) s = bKeywords.getValue().replace(/;/g," ");
			s = bName.getValue() + " " + s + " " + bTitle.getValue();
			s = s.toLowerCase();
			if (HypCommon.searchMatch(sbox, s) >= 0)//found something
				createResNode(bName.getValue(), bURL.getValue(), bIcon.getValue());
		   } catch (err) {}
		}
	}
}

function searchHist(sbox)
{	
	var allhist = histDS.getAllResources();
	while (allhist.hasMoreElements())
	{
		var hnode = allhist.getNext();
		if (hnode.isContainer() == false)
		{
			var s = "";
			var hName = hnode.getTarget("http://home.netscape.com/NC-rdf#Name");
			var hURL = hnode.getTarget("http://home.netscape.com/NC-rdf#URL");
			var hKeywords = hnode.getTarget("http://home.netscape.com/NC-rdf#OrigKeywords");
			if (hKeywords != null) s = hKeywords.getValue().replace(/;/g," ");
			s = hName.getValue() + " " + s + " " + hURL.getValue();
			s = s.toLowerCase();
			if (HypCommon.searchMatch(sbox, s) >= 0)//found something
				createResNode(hName.getValue(), hURL.getValue(), null);
		}
	}
}

function showTree(j)
{
	bklist.hidden = true;
	histlist.hidden = true;
	fastbklist.hidden = true;
	resultlist.hidden = true;
	
	if (treeshown < 4) oldtreeshown = treeshown;
	
	switch (j)
	{
		case 1 : bksearchTB.value = ""; captitle.label = HypCommon.getString("SB_SBK"); bklist.hidden = false; break;
		case 2 : bksearchTB.value = ""; captitle.label = HypCommon.getString("SB_SHS"); histlist.hidden = false; break;
		case 3 : bksearchTB.value = ""; captitle.label = HypCommon.getString("SB_SFBK"); fastbklist.hidden = false; break;
		case 4 : resultlist.hidden = false; break;
	}
	
	treeshown = j;
}


function tvisitBk(e)
{
	var i = bktree.view.selection.currentIndex;
	if (i == -1) return;
	if (bktree.view.isContainer(i)) return;
	var opentab = false
	if (typeof(e) != "number")
	{
		if (e.button == 1) opentab = true; //double mid mouse button click...thus open in tab
	}
	else
	{
		if (e == 1) opentab = true;
	}
	Hyper.OpenBK(bktree.view.getResourceAtIndex(i).Value, opentab);
}

function tvisitFastBk(e)
{
	var i = fastbktree.view.selection.currentIndex;
	if (i == -1) return;
	if (fastbktree.view.isContainer(i)) return;
	var opentab = false
	if (typeof(e) != "number")
	{
		if (e.button == 1) opentab = true; //double mid mouse button click...thus open in tab
	}
	else
	{
		if (e == 1) opentab = true;
	}
	Hyper.OpenFBK(fastbktree.view.getResourceAtIndex(i).Value, opentab);
}

function tvisitHist(e)
{
	var i = histtree.view.selection.currentIndex;
	if (i == -1) return;
	if (histtree.view.isContainer(i)) return;
	Hyper.openNewTab(histtree.view.getResourceAtIndex(i).Value);
}

function tvisitRes(e)
{
	var i = restree.view.selection.currentIndex;
	if (i == -1) return;
	Hyper.openNewTab(restree.view.getItemAtIndex(i).id);
}

//context menu functionality

function CMRename()
{
	var i = bktree.view.selection.currentIndex;
	if (i == -1) return;
		
	var s = bktree.view.getResourceAtIndex(i).Value;
	HypCommon.BKRename(s, bookDS, histDS);
	bookDS.save();
}

function CMDelete()
{
	var i = bktree.view.selection.currentIndex;
	if (i == -1) return;
	
	var msg = HypCommon.getString("SURE_DELBK");
	
	var s = bktree.view.getResourceAtIndex(i).Value;
	if (bktree.view.isContainer(i)) msg = HypCommon.getString("DEL_BKANDBKS");
	
	if (confirm(msg)) HypCommon.BKDelete(s, bookDS, histDS);
	
	bookDS.save();
}

function CMTour()
{
	var i = bktree.view.selection.currentIndex;
	if (i == -1) return;
	var bkuri = bktree.view.getResourceAtIndex(i).Value;
	
	if (!bktree.view.isContainer(i))
	{
		var paruri;
		try {
			paruri = bktree.view.getItemAtIndex(bktree.view.BKgetParentIndex(i)).id;
		} 
		catch (err) { 
			paruri = "NC:BookmarksRoot"; 
		}
		var bkuri = bktree.view.getResourceAtIndex(i).Value;
	
		Hyper.BookmarkTour(paruri, bkuri);
	}
	else
	{
		Hyper.BookmarkTour(bkuri, null);
	}
}

function CMSort()
{
	var i = bktree.view.selection.currentIndex;
	//if (i == -1) return;
	var paruri = null;
	
	try {
		paruri = bktree.view.getItemAtIndex(bktree.view.BKgetParentIndex(i)).id;
	}
	catch (err) //if fail then must need root
	{
		paruri = "NC:BookmarksRoot";
	}
	
	var par = bookDS.getNode(paruri);
	HypCommon.BKSortFolder(bookDS, par);
	if (paruri == "NC:BookmarksRoot") HypCommon.BKSortFolder(histDS, histDS.getNode(paruri));
}

function CMProp()
{
	var i = bktree.view.selection.currentIndex;
	if (i == -1) return;
			
	var s = bktree.view.getResourceAtIndex(i).Value;
	window.openDialog("chrome://hyper/content/hyperBKProp.xul", "" , "centerscreen,chrome,dialog=yes,close,modal=yes,resizable,height=200,width=450", s, bookDS);
}

function CMCopy()
{
	var i = bktree.view.selection.currentIndex;
	if (i == -1) return;
	
	var s = bktree.view.getResourceAtIndex(i).Value;
				
	//var s = bktree.view.getItemAtIndex(i).id;
	
	var copynode = bookDS.getNode(s);
	if (copynode.isContainer()) return;
	var copytext = copynode.getTarget("http://home.netscape.com/NC-rdf#URL").getValue();
	HypCommon.clipBoard(copytext);
}

