var bookDS = null;
var bklist1 =  null;
var topBKDS1 =  null;

var bklist2 =  null;
var topBKDS2 =  null;

function Startup()
{
	var pathBDS = "file://"+HypCommon.userHome("", "hyperBookmarks.rdf");   //PATH TO USER BOOKMARK FILE
	bookDS = new RDFDataSource(pathBDS);
	
	ComputeTopBK();
	
	bklist1 = document.getElementById("bklist1");
	bklist1.database.AddDataSource(topBKDS1.getRawDataSource());
	bklist1.builder.rebuild();
	
	bklist2 = document.getElementById("bklist2");
	bklist2.database.AddDataSource(topBKDS2.getRawDataSource());
	bklist2.builder.rebuild();
}

function openLink(x)
{
	var hlink = "";
	if (x == 1)
		hlink = bklist1.getItemAtIndex(bklist1.selectedIndex).id;
	else 
		hlink = bklist2.getItemAtIndex(bklist2.selectedIndex).id;
	hlink = bookDS.getNode(hlink).getTarget("http://home.netscape.com/NC-rdf#URL").getValue();
	
	window.open(hlink);
}
function openLinkCache(x)
{
	var hlink = "";
	if (x == 1)
		hlink = bklist1.getItemAtIndex(bklist1.selectedIndex).id;
	else 
		hlink = bklist2.getItemAtIndex(bklist2.selectedIndex).id;
	hlink = bookDS.getNode(hlink).getTarget("http://home.netscape.com/NC-rdf#ShortcutURL").getValue();
		
	window.open(hlink);
}


function ComputeTopBK() //should be similar as Hyper.TopVisited
{
	var bkarr = new Array();
	var bks = bookDS.getAllResources();
	while (bks.hasMoreElements()) 
	{
		var bk = bks.getNext();
		if (!bk.isContainer()) bkarr[bkarr.length] = bk; //to array
	}
	bkarr.sort(HypCommon.bkvcsortswap);
	
	topBKDS1 = new RDFDataSource();
	var troot1 = topBKDS1.getNode("NC:TopBKRoot");
	troot1.makeSeq();
	
	topBKDS2 = new RDFDataSource();
	var troot2 = topBKDS2.getNode("NC:TopBKRoot");
	troot2.makeSeq();
	
	for(var i=0; (i<bkarr.length) && (i<10); i++)
	{
		var name = bkarr[i].getTarget("http://home.netscape.com/NC-rdf#Name");
		var url = bkarr[i].getTarget("http://home.netscape.com/NC-rdf#URL");
		var icon = bkarr[i].getTarget("http://home.netscape.com/NC-rdf#Icon");
		var image = bkarr[i].getTarget("http://home.netscape.com/NC-rdf#Image");
		var lvisit = bkarr[i].getTarget("http://home.netscape.com/WEB-rdf#LastVisitDate");
		var seref = bkarr[i].getTarget("http://home.netscape.com/NC-rdf#Referrer");
		if (seref == null) 
			seref = " ";
		else
			seref = seref.getValue();
		
		var tbk = null; 
		if (i < 5)
			tbk = topBKDS1.getNode(bkarr[i].getValue());
		else 
			tbk = topBKDS2.getNode(bkarr[i].getValue());
		
		tbk.addTarget("http://home.netscape.com/NC-rdf#Name", name.getValue());
		tbk.addTarget("http://home.netscape.com/NC-rdf#URL", url.getValue());
		if (icon != null) tbk.addTarget("http://home.netscape.com/NC-rdf#Icon", icon.getValue());
		tbk.addTarget("http://home.netscape.com/NC-rdf#Image", image.getValue());
		tbk.addTarget("http://home.netscape.com/WEB-rdf#LastVisitDate", lvisit.getValue());
		tbk.addTarget("http://home.netscape.com/NC-rdf#Referrer", seref);
		
		if (i < 5)
			troot1.addChild(tbk);
		else
			troot2.addChild(tbk);
	}
}