var http_request = null;
var bookDS;
var listDS;
var rstart = null; //depricated
var rootn = null;
var vlist = null;
var cbox = null;
var newds;
var pmeter;
var stopflag; 
var enum1;  //enumeration holding bookmarks
var btnverify; //Check Bookmarks Button
var btnstop;
var sbpan1;
var bookmark; //current monitored bookmark node
var Hyper;
var months = new Array("x", "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec");

function finishLoop()
{
	pmeter.setAttribute("mode", "determined");
	pmeter.setAttribute("value", "100%");
	btnstop.setAttribute("disabled", "true");
	btnverify.setAttribute("disabled", "false");
	sbpan1.label = HypCommon.getString("FINISHED_VERIFY");
}

function checkNextBookmark()
{
	bookmark = null;
		
	if (enum1.hasMoreElements()) bookmark = enum1.getNext();
		
	if (bookmark == null) { finishLoop(); return; } //no more nodes left thus finished
	
	makeRequest(true);
	
}

function onChange()
{
	if (http_request.readyState == 4) //received response can check
	{
	    try
	    {
		if (http_request.status == 405) //method not allowed
		{
			makeRequest(false); //make a GET request instead
			return;
		}
		if (http_request.status == 301) //moved permanently
		{
			alert(http_request.getResponseHeader("Location")); //TODO
		}
		var resp = "";
		var fs = true;
		switch (http_request.status)
		{
			case 200 : resp = "200/"+HypCommon.getString("HTTPSC_200"); break;
			case 301 : resp = "301/"+HypCommon.getString("HTTPSC_301"); break; //need to sort out
			case 302 : resp = "302/"+HypCommon.getString("HTTPSC_302"); break;
			case 307 : resp = "307/"+HypCommon.getString("HTTPSC_307"); break;
			case 401 : resp = "401/"+HypCommon.getString("HTTPSC_401"); fs = false; break;
			case 404 : resp = "404/"+HypCommon.getString("HTTPSC_404"); fs = false; break;
			case 403 : resp = "403/"+HypCommon.getString("HTTPSC_403"); fs = false; break;
			case 405 : resp = "405/"+HypCommon.getString("HTTPSC_405"); break;
			case 500 :
			case 501 :
			case 502 :
			case 503 :
			case 504 : resp = "50x/"+HypCommon.getString("HTTPSC_50x"); fs = false; break;
			default : resp = "unknown/"+http_request.status;
		}
		bookmark.addTargetOnce("http://home.netscape.com/WEB-rdf#status", resp);
		
		if (fs)
			bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Image", "chrome://hyper/content/images/good.png");
		else
			bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Image", "chrome://hyper/content/images/cross.png");
		
		var st = bookmark.getTarget("http://home.netscape.com/WEB-rdf#LastVisitDate");
		var serlm = http_request.getResponseHeader("Last-Modified");
		if ((serlm != null) && (st != null)) //compare dates
		{
			bookmark.addTargetOnce("http://home.netscape.com/WEB-rdf#LastModifiedDate", serlm);
			st = st.getValue();
			var bkdate = HypCommon.BKdateNormalize(st);
			
			serlm = serlm.substr(5, 11);
			var serd = serlm.substr(0, 2);
			var serm = serlm.substr(3, 3);
			for(var i=0; i<months.length; i++)
			{
				if (months[i] == serm)
				{
					if (i < 10) serm = "0"+i;
					else serm = i;
					break;
				}
			}
			var sery = serlm.substr(7, 4);
			
			var serdate = parseInt(sery+serm+serd);
			
			if (serdate > bkdate) 
			{
				bookmark.addTargetOnce("http://home.netscape.com/WEB-rdf#status", HypCommon.getString("VER_UPDT")+" "+resp);
				bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Image", "chrome://hyper/content/images/escl.png");
			}
		}
	   }
	   catch (err) 
	   {
	   	bookmark.addTargetOnce("http://home.netscape.com/WEB-rdf#status", HypCommon.getString("VER_FAIL"));
	   	bookmark.addTargetOnce("http://home.netscape.com/NC-rdf#Image", "chrome://hyper/content/images/cross.png");
	   }
		
	   if (stopflag == true) //user requested stop
	   {
		finishLoop();
		return;
	   }
	   else
		checkNextBookmark();
       	}
}

function makeRequest(head) 
{
        http_request = new XMLHttpRequest(); 

        if (!http_request) 
        {
            alert('Error creating XMLHTTP instance');
            http_request = null;
            finishLoop();
            return false;
        }
        http_request.onreadystatechange = onChange;
        
        var url = bookmark.getTarget("http://home.netscape.com/NC-rdf#URL");
        bookmark.addTargetOnce("http://home.netscape.com/WEB-rdf#status", HypCommon.getString("VER_CHCK"));
        
        if (head) http_request.open("HEAD", url.getValue(), true); //asynchronously
        else http_request.open("GET", url.getValue(), true); //asynchronously
        
        http_request.send(null);
        
        return true;
}


function Startup()
{
	Hyper = window.arguments[0];
	bookDS = Hyper.bookDS;
	rstart = window.arguments[1];
	
	newds = false;
	vlist = document.getElementById("vlist");
	cbox = document.getElementById("clist");
	cbox.removeAllItems();
	cbox.appendItem("All Bookmarks", "NC:BookmarksRoot"); //cbox.appendItem(HypCommon.getString("ALL_BOOKMARKS"), "NC:BookmarksRoot");
	HypCommon.addFoldersCBox(bookDS.getNode("NC:BookmarksRoot"), cbox);
	cbox.selectedIndex = 0;
	cbox.addEventListener("ValueChange", cboxselectedIndexChanged, false);
		
	pmeter = window.document.getElementById("pmeter");
	btnverify = window.document.getElementById("btnverify");
	btnstop = window.document.getElementById("btnstop");
	btnstop.setAttribute("disabled", "true");
	sbpan1 = window.document.getElementById("span1");
	sbpan1.label = HypCommon.getString("PRESS_VERIFY");
	
	stopflag = false;
	
	listDS = new RDFDataSource(); 
	vlist.database.AddDataSource(listDS.getRawDataSource());
	
	cboxselectedIndexChanged(); //fire to fill in first time
}


function Stop()
{
	stopflag = true;
	btnstop.setAttribute("disabled", "true");
	btnverify.setAttribute("disabled", "false");
	sbpan1.label = HypCommon.getString("STOP_VERIFY");
}

function cboxselectedIndexChanged()
{
	var allres = listDS.getAllResources();
	while (allres.hasMoreElements()) //empty datasource
	{
		var res = allres.getNext();
		listDS.deleteRecursive(res);
	}
	
	rootn = listDS.getNode("NC:LRoot"); //reset initial root
	rootn.makeSeq();
	
	var bks;	
	if (cbox.value == "NC:BookmarksRoot")
		bks = bookDS.getAllResources();
	else
	{
		var parbks = bookDS.getNode(cbox.value);
		bks = parbks.getChildren();
	}
	
	while (bks.hasMoreElements())
	{
		var bk = bks.getNext();
		if (!bk.isContainer())
		{//add to listDS
		   try{	
			var name = bk.getTarget("http://home.netscape.com/NC-rdf#Name");
			var url = bk.getTarget("http://home.netscape.com/NC-rdf#URL");
			var lvisit = bk.getTarget("http://home.netscape.com/WEB-rdf#LastVisitDate");
			var icon = bk.getTarget("http://home.netscape.com/NC-rdf#Icon");
			
			var s = url.getValue();
			if (s.indexOf("http") == 0)
			{
				var ln = listDS.getNode(bk.getValue());
				ln.addTarget("http://home.netscape.com/NC-rdf#Name", name.getValue());
				ln.addTarget("http://home.netscape.com/NC-rdf#URL", url.getValue());
				ln.addTarget("http://home.netscape.com/WEB-rdf#LastVisitDate", lvisit.getValue());
				ln.addTarget("http://home.netscape.com/WEB-rdf#status", HypCommon.getString("VER_UNKN"));
				ln.addTarget("http://home.netscape.com/WEB-rdf#LastModifiedDate", HypCommon.getString("VER_UNKN"));
				ln.addTarget("http://home.netscape.com/NC-rdf#Image", "chrome://hyper/content/images/none.png");
				rootn.addChild(ln);
			
				if (icon != null)
					ln.addTarget("http://home.netscape.com/NC-rdf#Icon", icon.getValue());
				else
					ln.addTarget("http://home.netscape.com/NC-rdf#Icon", "chrome://hyper/content/images/file.png");
			}
		    }
		    catch (err) {}
		}
	}
	
	enum1 = rootn.getChildren(); //listDS.getAllResources();
}

function CheckBookmarks() //Button on press Handler
{
	stopflag = false;
	btnstop.setAttribute("disabled", "false");
	btnverify.setAttribute("disabled", "true");
	sbpan1.label = HypCommon.getString("CHECKING_BK");
	
	//removed from here
	pmeter.setAttribute("mode", "undetermined");
	checkNextBookmark();
}

function linkClick()
{
	Hyper.OpenBK(vlist.getItemAtIndex(vlist.selectedIndex).id, true);
}

function openUpdatedInTabs()
{
	if (rootn == null) 
	{
		alert(HypCommon.getString("PERFRM_VERIFY_F"));
		return;
	}
	var flg = false;
	var bks = rootn.getChildren();
	while (bks.hasMoreElements())
	{
		var bk = bks.getNext();
		if (!bk.isContainer())
		{
			var st = bk.getTarget("http://home.netscape.com/WEB-rdf#status");
			st = st.getValue();
			if (st.indexOf("updated") >= 0)
			{
				Hyper.OpenBK(bk.getValue(), true);
				flg = true;
			}
		}
	}
	if (flg == false) alert(HypCommon.getString("NOTHING_UPDATED"));
}


///////
function VdeleteBK()
{
	var nname = vlist.getItemAtIndex(vlist.selectedIndex).id;
	if (!confirm(HypCommon.getString("SURE_DELBK"))) return;
	HypCommon.BKDelete(nname, bookDS, Hyper.histDS);
	var nd = listDS.getNode(nname);
	listDS.deleteRecursive(nd);
}

function VrelocateBK()
{
	var uri = vlist.getItemAtIndex(vlist.selectedIndex).id;
	var nbk = Hyper.bookDS.getNode(uri);
	Hyper.RetrieveBK(nbk);
}