
var Hyper;
var returnval;
var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

function Startup()
{
	Hyper = window.arguments[0];
	returnval = window.arguments[1];
	
	Hyper.bookDS.save(); //save to disk (to save root nodes)
	Hyper.histDS.save();
	Hyper.fastbkDS.save();
	
	//Now Set some Default Options
	try {
		prefs.setIntPref("dom.max_script_run_time", 30);
		//prefs.setBoolPref("browser.chrome.toolbar_tips", false); //no longer needed now with new toolbar tip
	}
	catch (err) { alert(err.message); }
	
	//Create Folders
	try {
		var fol = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		var path = HypCommon.userHome("", "hyperCache");
		fol.initWithPath(path);
		if (!fol.exists()) fol.create(0x01, 0777); //create hyperCache folder
	} 
	catch (err) { alert(HypCommon.getString("WW_FAILED_BKCF")); }
	
	try {
		var fol = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		var path = HypCommon.userHome("", "hyperBKIC");
		fol.initWithPath(path);
		if (!fol.exists()) fol.create(0x01, 0777); //create hyperBKIC folder
	} 
	catch (err) { alert(HypCommon.getString("WW_FAILED_BKIT")); }
	
	try {
		var fol = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		var path = HypCommon.userHome("", "hyperBackup");
		fol.initWithPath(path);
		if (!fol.exists()) fol.create(0x01, 0777); //create hyperBackup folder
		} 
	catch (err) { alert(HypCommon.getString("WW_FAILED_BKB")); }
	
	
}


function finish()
{
	var bhide = document.getElementById("bhidf");
	if (bhide.selected) prefs.setBoolPref("extensions.hyper.hideOldBKM", false);
	
	/*
	//set google developer key
	var gdevkey = document.getElementById("gogdevkey");
	if (gdevkey.value != "") prefs.setCharPref("extensions.hyper.googleDevKey", gdevkey.value);
	*/
	
	//disable wizard for next time
	prefs.setBoolPref("extensions.hyper.firsttime", false);
	
	var bexp = document.getElementById("expobk");
	returnval.expbk = bexp.checked;
	
	return true;
}